//
// FPGA PACMAN clock generator
//
// Version : beta1
//
// Copyright(c) 2002 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This program is freeware for non-commercial use. 
// An author does no guarantee about this program.
// You can use this under your own risk. 
//
//

module clock(CLKIN,CLK_2_3,CLK_1_6,CLK_1_6_n);
input  CLKIN;
output CLK_2_3;
output CLK_1_6;
output CLK_1_6_n;

//
// 2/3 clock divider(duty 33%)
//

reg [1:0] clk_pris;
//PCLK  0101010101010101010
//pri0  0111100111100111100
//pri1  0110000110000110000
//12MHz 0100100100100100100
always @(posedge CLKIN)
begin
	if(~clk_pris[1])
		clk_pris[0] <= ~clk_pris[0];
	if(clk_pris[0] == clk_pris[1])
		clk_pris[1] <= ~clk_pris[1];
end
// 2/3 clock duty 33%
assign CLK_2_3 = clk_pris[0] & (CLKIN == clk_pris[1]);

//
// 1/3 clock divider (duty 50%)
//
reg CLK_16 , CLK_16n;
always @(posedge CLK_2_3)
begin
	CLK_16n <=  CLK_16;
	CLK_16  <= ~CLK_16;
end
assign CLK_1_6   = CLK_16;
assign CLK_1_6_n = CLK_16n;

endmodule
