//
// FPGA PACMAN IRQ / vector handler
//
// Version : beta1
//
// Copyright(c) 2002 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This program is freeware for non-commercial use. 
// An author does no guarantee about this program.
// You can use this under your own risk. 
//
//

module irq(n_M1,n_IORQ,IRQEN,n_IRQTRG,DI,n_IRQ,DO,DE);

input n_M1;
input n_IORQ;
input IRQEN;
input n_IRQTRG;
input [7:0] DI;
output n_IRQ;
output [7:0] DO;
output DE;

reg vector_latch;

// I/O write -> set vector
always @(negedge n_IORQ)
begin
	if(n_M1 == 1'b1)
		vector_latch <= DI;
end

// M1 & IORQ = vector out
assign DE = (~n_M1 & ~n_IORQ);
assign DO = DE ? vector_latch : 8'h00;

// IRQ signal
reg irq_latch;
always @(negedge n_IRQTRG or negedge IRQEN)
begin
	if(IRQEN==0) //enable fall
		irq_latch <= 1'b1; //clear
	else // trigger fall
		irq_latch <= 1'b0; //enable
end
assign n_IRQ = irq_latch;

endmodule
