//
// FPGA PACMAN Z80 extender
//
// Version : beta1
//
// Copyright(c) 2002 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This program is freeware for non-commercial use. 
// An author does no guarantee about this program.
// You can use this under your own risk. 
//
//

module Z80EX(
	A,	DIN,	DOUT,	BUSWO,
	RESET_N,	INT_N,	NMI_N, WAIT_N,
	M1_N,	MREQ_N,	IORQ_N,	RD_N,	WR_N,
	RFSH_N,	HALT_N,	CLK2X,CLK);

// I/O assign
output [15:0] A;
input  [7:0] DIN;
output [7:0] DOUT;
input  RESET_N,INT_N,NMI_N,WAIT_N,CLK2X,CLK;
output M1_N,MREQ_N,IORQ_N,RD_N,WR_N,RFSH_N,HALT_N,BUSWO;

// Z80IP interface
T80s z80core (
	.RESET_n(RESET_N),
	.CLK_n(CLK),
	.WAIT_n(1'b1),
	.INT_n(INT_N),
	.NMI_n(NMI_N),
	.BUSRQ_n(1'b1),
	.M1_n(M1_N),
	.MREQ_n(MREQ_N),
	.IORQ_n(IORQ_N),
	.RD_n(RD_N),
	.WR_n(WR_N),
	.RFSH_n(RFSH_N),
	.HALT_n(HALT_N),
	.BUSAK_n(),
	.A(A),
	.DI(DIN),
	.DO(DOUT)
);
assign BUSWO = 1'b1;

endmodule
